diff --git a/MAINTAINERS b/MAINTAINERS
index 33fd4652a4..78872169cd 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -474,7 +474,7 @@ S:	Maintained
 T:	git git://git.denx.de/u-boot-efi.git
 F:	doc/README.uefi
 F:	doc/README.iscsi
-F:	Documentation/efi.rst
+F:	doc/efi.rst
 F:	include/capitalization.h
 F:	include/cp1250.h
 F:	include/cp437.h
diff --git a/Makefile b/Makefile
index 9fb90c0779..e4c2d4a517 100644
--- a/Makefile
+++ b/Makefile
@@ -168,7 +168,7 @@ MAKEFLAGS += --no-print-directory
 # Use 'make C=2' to enable checking of *all* source files, regardless
 # of whether they are re-compiled or not.
 #
-# See the file "Documentation/sparse.txt" for more details, including
+# See the file "doc/sparse.txt" for more details, including
 # where to get the "sparse" utility.
 
 ifeq ("$(origin C)", "command line")
@@ -1883,7 +1883,7 @@ help:
 	@echo  '  coccicheck      - Execute static code analysis with Coccinelle'
 	@echo  ''
 	@echo  'Documentation targets:'
-	@$(MAKE) -f $(srctree)/Documentation/Makefile dochelp
+	@$(MAKE) -f $(srctree)/doc/Makefile dochelp
 	@echo  ''
 	@echo  '  make V=0|1 [targets] 0 => quiet build (default), 1 => verbose build'
 	@echo  '  make V=2   [targets] 2 => give reason for rebuild of target'
@@ -1912,7 +1912,7 @@ DOC_TARGETS := xmldocs latexdocs pdfdocs htmldocs epubdocs cleandocs \
 	       linkcheckdocs dochelp refcheckdocs
 PHONY += $(DOC_TARGETS)
 $(DOC_TARGETS): scripts_basic FORCE
-	$(Q)$(MAKE) $(build)=Documentation $@
+	$(Q)$(MAKE) $(build)=doc $@
 
 endif #ifeq ($(config-targets),1)
 endif #ifeq ($(mixed-targets),1)
diff --git a/Documentation/Makefile b/doc/Makefile
similarity index 91%
rename from Documentation/Makefile
rename to doc/Makefile
index 2ca77ad0f2..5135a96e88 100644
--- a/Documentation/Makefile
+++ b/doc/Makefile
@@ -8,7 +8,7 @@ subdir-y :=
 SPHINXBUILD   = sphinx-build
 SPHINXOPTS    =
 SPHINXDIRS    = .
-_SPHINXDIRS   = $(patsubst $(srctree)/Documentation/%/conf.py,%,$(wildcard $(srctree)/Documentation/*/conf.py))
+_SPHINXDIRS   = $(patsubst $(srctree)/doc/%/conf.py,%,$(wildcard $(srctree)/doc/*/conf.py))
 SPHINX_CONF   = conf.py
 PAPER         =
 BUILDDIR      = $(obj)/output
@@ -49,10 +49,10 @@ loop_cmd = $(echo-cmd) $(cmd_$(1)) || exit;
 #    * cache folder relative to $(BUILDDIR)/.doctrees
 # $4 dest subfolder e.g. "man" for man pages at media/man
 # $5 reST source folder relative to $(srctree)/$(src),
-#    e.g. "media" for the linux-tv book-set at ./Documentation/media
+#    e.g. "media" for the linux-tv book-set at ./doc/media
 
 quiet_cmd_sphinx = SPHINX  $@ --> file://$(abspath $(BUILDDIR)/$3/$4)
-      cmd_sphinx = $(MAKE) BUILDDIR=$(abspath $(BUILDDIR)) $(build)=Documentation/media $2 && \
+      cmd_sphinx = $(MAKE) BUILDDIR=$(abspath $(BUILDDIR)) $(build)=doc/media $2 && \
 	PYTHONDONTWRITEBYTECODE=1 \
 	BUILDDIR=$(abspath $(BUILDDIR)) SPHINX_CONF=$(abspath $(srctree)/$(src)/$5/$(SPHINX_CONF)) \
 	$(SPHINXBUILD) \
@@ -102,7 +102,7 @@ refcheckdocs:
 
 cleandocs:
 	$(Q)rm -rf $(BUILDDIR)
-	$(Q)$(MAKE) BUILDDIR=$(abspath $(BUILDDIR)) $(build)=Documentation/media clean
+	$(Q)$(MAKE) BUILDDIR=$(abspath $(BUILDDIR)) $(build)=doc/media clean
 
 dochelp:
 	@echo  ' Linux kernel internal documentation in different formats from ReST:'
@@ -121,4 +121,4 @@ dochelp:
 	@echo  '  make SPHINX_CONF={conf-file} [target] use *additional* sphinx-build'
 	@echo  '  configuration. This is e.g. useful to build with nit-picking config.'
 	@echo
-	@echo  '  Default location for the generated documents is Documentation/output'
+	@echo  '  Default location for the generated documents is doc/output'
diff --git a/Documentation/conf.py b/doc/conf.py
similarity index 100%
rename from Documentation/conf.py
rename to doc/conf.py
diff --git a/Documentation/devicetree/bindings/arm/l2c2x0.txt b/doc/device-tree-bindings/arm/l2c2x0.txt
similarity index 100%
rename from Documentation/devicetree/bindings/arm/l2c2x0.txt
rename to doc/device-tree-bindings/arm/l2c2x0.txt
diff --git a/Documentation/devicetree/bindings/axi/gdsys,ihs_axi.txt b/doc/device-tree-bindings/axi/gdsys,ihs_axi.txt
similarity index 100%
rename from Documentation/devicetree/bindings/axi/gdsys,ihs_axi.txt
rename to doc/device-tree-bindings/axi/gdsys,ihs_axi.txt
diff --git a/Documentation/devicetree/bindings/board/gdsys,board_gazerbeam.txt b/doc/device-tree-bindings/board/gdsys,board_gazerbeam.txt
similarity index 100%
rename from Documentation/devicetree/bindings/board/gdsys,board_gazerbeam.txt
rename to doc/device-tree-bindings/board/gdsys,board_gazerbeam.txt
diff --git a/Documentation/devicetree/bindings/clk/fsl,mpc83xx-clk.txt b/doc/device-tree-bindings/clock/fsl,mpc83xx-clk.txt
similarity index 100%
rename from Documentation/devicetree/bindings/clk/fsl,mpc83xx-clk.txt
rename to doc/device-tree-bindings/clock/fsl,mpc83xx-clk.txt
diff --git a/Documentation/devicetree/bindings/cpu/fsl,mpc83xx.txt b/doc/device-tree-bindings/cpu/fsl,mpc83xx.txt
similarity index 100%
rename from Documentation/devicetree/bindings/cpu/fsl,mpc83xx.txt
rename to doc/device-tree-bindings/cpu/fsl,mpc83xx.txt
diff --git a/Documentation/devicetree/bindings/misc/fsl,mpc83xx-serdes.txt b/doc/device-tree-bindings/misc/misc/fsl,mpc83xx-serdes.txt
similarity index 100%
rename from Documentation/devicetree/bindings/misc/fsl,mpc83xx-serdes.txt
rename to doc/device-tree-bindings/misc/misc/fsl,mpc83xx-serdes.txt
diff --git a/Documentation/devicetree/bindings/misc/gdsys,io-endpoint.txt b/doc/device-tree-bindings/misc/misc/gdsys,io-endpoint.txt
similarity index 100%
rename from Documentation/devicetree/bindings/misc/gdsys,io-endpoint.txt
rename to doc/device-tree-bindings/misc/misc/gdsys,io-endpoint.txt
diff --git a/Documentation/devicetree/bindings/misc/gdsys,iocon_fpga.txt b/doc/device-tree-bindings/misc/misc/gdsys,iocon_fpga.txt
similarity index 100%
rename from Documentation/devicetree/bindings/misc/gdsys,iocon_fpga.txt
rename to doc/device-tree-bindings/misc/misc/gdsys,iocon_fpga.txt
diff --git a/Documentation/devicetree/bindings/misc/gdsys,iocpu_fpga.txt b/doc/device-tree-bindings/misc/misc/gdsys,iocpu_fpga.txt
similarity index 100%
rename from Documentation/devicetree/bindings/misc/gdsys,iocpu_fpga.txt
rename to doc/device-tree-bindings/misc/misc/gdsys,iocpu_fpga.txt
diff --git a/Documentation/devicetree/bindings/misc/gdsys,soc.txt b/doc/device-tree-bindings/misc/misc/gdsys,soc.txt
similarity index 100%
rename from Documentation/devicetree/bindings/misc/gdsys,soc.txt
rename to doc/device-tree-bindings/misc/misc/gdsys,soc.txt
diff --git a/Documentation/devicetree/bindings/ram/fsl,mpc83xx-mem-controller.txt b/doc/device-tree-bindings/ram/fsl,mpc83xx-mem-controller.txt
similarity index 100%
rename from Documentation/devicetree/bindings/ram/fsl,mpc83xx-mem-controller.txt
rename to doc/device-tree-bindings/ram/fsl,mpc83xx-mem-controller.txt
diff --git a/Documentation/devicetree/bindings/reserved-memory/reserved-memory.txt b/doc/device-tree-bindings/reserved-memory/reserved-memory.txt
similarity index 100%
rename from Documentation/devicetree/bindings/reserved-memory/reserved-memory.txt
rename to doc/device-tree-bindings/reserved-memory/reserved-memory.txt
diff --git a/Documentation/devicetree/bindings/timer/fsl,mpc83xx-timer.txt b/doc/device-tree-bindings/timer/fsl,mpc83xx-timer.txt
similarity index 100%
rename from Documentation/devicetree/bindings/timer/fsl,mpc83xx-timer.txt
rename to doc/device-tree-bindings/timer/fsl,mpc83xx-timer.txt
diff --git a/Documentation/efi.rst b/doc/efi.rst
similarity index 100%
rename from Documentation/efi.rst
rename to doc/efi.rst
diff --git a/Documentation/index.rst b/doc/index.rst
similarity index 100%
rename from Documentation/index.rst
rename to doc/index.rst
diff --git a/Documentation/linker_lists.rst b/doc/linker_lists.rst
similarity index 100%
rename from Documentation/linker_lists.rst
rename to doc/linker_lists.rst
diff --git a/Documentation/media/Makefile b/doc/media/Makefile
similarity index 89%
rename from Documentation/media/Makefile
rename to doc/media/Makefile
index 0efd18ab4d..b9b43a34c3 100644
--- a/Documentation/media/Makefile
+++ b/doc/media/Makefile
@@ -1,7 +1,7 @@
 # Rules to convert a .h file to inline RST documentation
 
-SRC_DIR=$(srctree)/Documentation/media
-PARSER = $(srctree)/Documentation/sphinx/parse-headers.pl
+SRC_DIR=$(srctree)/doc/media
+PARSER = $(srctree)/doc/sphinx/parse-headers.pl
 API = $(srctree)/include
 
 FILES = linker_lists.h.rst
diff --git a/Documentation/media/linker_lists.h.rst.exceptions b/doc/media/linker_lists.h.rst.exceptions
similarity index 100%
rename from Documentation/media/linker_lists.h.rst.exceptions
rename to doc/media/linker_lists.h.rst.exceptions
diff --git a/Documentation/serial.rst b/doc/serial.rst
similarity index 100%
rename from Documentation/serial.rst
rename to doc/serial.rst
diff --git a/Documentation/sphinx-static/theme_overrides.css b/doc/sphinx-static/theme_overrides.css
similarity index 100%
rename from Documentation/sphinx-static/theme_overrides.css
rename to doc/sphinx-static/theme_overrides.css
diff --git a/Documentation/sphinx/cdomain.py b/doc/sphinx/cdomain.py
similarity index 100%
rename from Documentation/sphinx/cdomain.py
rename to doc/sphinx/cdomain.py
diff --git a/Documentation/sphinx/kernel_include.py b/doc/sphinx/kernel_include.py
similarity index 100%
rename from Documentation/sphinx/kernel_include.py
rename to doc/sphinx/kernel_include.py
diff --git a/Documentation/sphinx/kerneldoc.py b/doc/sphinx/kerneldoc.py
similarity index 100%
rename from Documentation/sphinx/kerneldoc.py
rename to doc/sphinx/kerneldoc.py
diff --git a/Documentation/sphinx/kfigure.py b/doc/sphinx/kfigure.py
similarity index 100%
rename from Documentation/sphinx/kfigure.py
rename to doc/sphinx/kfigure.py
diff --git a/Documentation/sphinx/load_config.py b/doc/sphinx/load_config.py
similarity index 100%
rename from Documentation/sphinx/load_config.py
rename to doc/sphinx/load_config.py
diff --git a/Documentation/sphinx/parse-headers.pl b/doc/sphinx/parse-headers.pl
similarity index 99%
rename from Documentation/sphinx/parse-headers.pl
rename to doc/sphinx/parse-headers.pl
index d410f47567..d4f38262eb 100755
--- a/Documentation/sphinx/parse-headers.pl
+++ b/doc/sphinx/parse-headers.pl
@@ -382,7 +382,7 @@ ioctl.
 The EXCEPTIONS_FILE contain two rules to allow ignoring a symbol or
 to replace the default references by a custom one.
 
-Please read Documentation/doc-guide/parse-headers.rst at the Kernel's
+Please read doc/doc-guide/parse-headers.rst at the Kernel's
 tree for more details.
 
 =head1 BUGS
diff --git a/Documentation/sphinx/requirements.txt b/doc/sphinx/requirements.txt
similarity index 100%
rename from Documentation/sphinx/requirements.txt
rename to doc/sphinx/requirements.txt
diff --git a/Documentation/sphinx/rstFlatTable.py b/doc/sphinx/rstFlatTable.py
similarity index 99%
rename from Documentation/sphinx/rstFlatTable.py
rename to doc/sphinx/rstFlatTable.py
index 25feb0d35e..f9a4b46dbe 100755
--- a/Documentation/sphinx/rstFlatTable.py
+++ b/doc/sphinx/rstFlatTable.py
@@ -54,7 +54,7 @@ from docutils.utils import SystemMessagePropagation
 # ==============================================================================
 
 # The version numbering follows numbering of the specification
-# (Documentation/books/kernel-doc-HOWTO).
+# (doc/books/kernel-doc-HOWTO).
 __version__  = '1.0'
 
 PY3 = sys.version_info[0] == 3